VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form frmController 
   Caption         =   "Controller"
   ClientHeight    =   1620
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3570
   Icon            =   "frmController.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   1620
   ScaleWidth      =   3570
   StartUpPosition =   3  'Windows Default
   Begin MSCommLib.MSComm RobotLink 
      Left            =   3000
      Top             =   1440
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.CommandButton btnConnect 
      Caption         =   "Connect"
      Height          =   495
      Left            =   1118
      TabIndex        =   2
      Top             =   720
      Width           =   1335
   End
   Begin VB.ComboBox CommPort 
      Height          =   315
      Left            =   2400
      TabIndex        =   1
      Top             =   120
      Width           =   1095
   End
   Begin VB.Label lblConnected 
      Alignment       =   2  'Center
      Caption         =   "Connected to Robot"
      Height          =   255
      Left            =   480
      TabIndex        =   3
      Top             =   1320
      Visible         =   0   'False
      Width           =   2775
   End
   Begin VB.Label lblConnect 
      Caption         =   "Set Comm Port and Connect"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2415
   End
End
Attribute VB_Name = "frmController"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim dx As New DirectX8
Dim di As DirectInput8
Dim diDev As DirectInputDevice8
Dim diDevEnum As DirectInputEnumDevices8
Dim joyCaps As DIDEVCAPS
Dim JoyStick As DIJOYSTATE
Dim OnLine As Boolean
Dim DiProp_Dead As DIPROPLONG
Dim DiPRop_Range As DIPROPRANGE
Dim DiProp_Saturation As DIPROPLONG
Dim Motion As String
Dim Lights As String
Dim Tilt As String
Dim Pan As String
Dim Gripper As String
Dim CommandString As String

Public Sub SendCommand()
    RobotLink.Output = "ZZ" & CommandString
End Sub
Public Sub PauseIt(Seconds As Double)
Dim Pause As Double
Pause = Now()
Do Until (Now - Pause) >= (Seconds / (24# * 3600#))
DoEvents
Loop
End Sub
Public Sub JoyStickLoop()
While OnLine = True
    Motion = " "
    Pan = " "
    Tilt = " "
    Lights = " "
    Gripper = " "
    diDev.GetDeviceStateJoystick JoyStick
    'Get joystick positions for movement
    Select Case JoyStick.z
        Case 0 To 2000
            Motion = "F"
        Case 2001 To 4000
            Motion = "f"
        Case 4001 To 6000
            Motion = "S"
        Case 6001 To 8000
            Motion = "b"
        Case 8001 To 10000
            Motion = "B"
    End Select
    Select Case JoyStick.rz
        Case 0 To 1500
            Motion = "L"
        Case 8501 To 10000
            Motion = "R"
    End Select
    Select Case JoyStick.y
        Case 0 To 2000
            Tilt = "U"
        Case 2001 To 4000
            Tilt = "u"
        Case 4001 To 6000
            Tilt = "C"
        Case 6001 To 8000
            Tilt = "d:"
        Case 8001 To 10000
            Tilt = "D"
    End Select
    Select Case JoyStick.x
        Case 0 To 2000
            Pan = "L"
        Case 2001 To 4000
            Pan = "l"
        Case 4001 To 6000
            Pan = "C"
        Case 6001 To 8000
            Pan = "r"
        Case 8001 To 10000
            Pan = "R"
    End Select

    'Get the button status - note the button array is 1 less
    'than the numbers on the controller.
    If JoyStick.Buttons(6) Then
        Lights = "L"
    End If
    If JoyStick.Buttons(7) Then
        Lights = "R"
    End If
        If JoyStick.Buttons(4) Then
        Gripper = "O"
    End If
    If JoyStick.Buttons(5) Then
        Gripper = "C"
    End If
    CommandString = Motion & Pan & Tilt & Lights & Gripper
    SendCommand
    DoEvents
Wend
End Sub

Private Sub btnConnect_Click()
'Connect to the Robot via the BlueTooth adaptor.

RobotLink.CommPort = CommPort.Text
RobotLink.PortOpen = True

'Initialize the Joystick Object
Set di = dx.DirectInputCreate
Set diDevEnum = di.GetDIDevices(DI8DEVCLASS_GAMECTRL, DIEDFL_ATTACHEDONLY)
Set diDev = di.CreateDevice(diDevEnum.GetItem(1).GetGuidInstance)
diDev.SetCommonDataFormat DIFORMAT_JOYSTICK
diDev.GetCapabilities joyCaps
 
With DiProp_Dead
.lData = 1000
.lHow = DIPH_BYOFFSET
 
.lObj = DIJOFS_X
diDev.SetProperty "DIPROP_DEADZONE", DiProp_Dead
 
.lObj = DIJOFS_Y
diDev.SetProperty "DIPROP_DEADZONE", DiProp_Dead

.lObj = DIJOFS_Y
diDev.SetProperty "DIPROP_DEADZONE", DiProp_Dead

.lObj = DIJOFS_RZ
diDev.SetProperty "DIPROP_DEADZONE", DiProp_Dead
End With
 
With DiProp_Saturation
.lData = 9500
.lHow = DIPH_BYOFFSET
 
.lObj = DIJOFS_X
diDev.SetProperty "DIPROP_SATURATION", DiProp_Saturation
 
.lObj = DIJOFS_Y
diDev.SetProperty "DIPROP_SATURATION", DiProp_Saturation
End With
 
With DiPRop_Range
.lHow = DIPH_DEVICE
.lMin = 0
.lMax = 10000
End With
 
diDev.SetProperty "DIPROP_RANGE", DiPRop_Range
diDev.Acquire

lblConnected.Visible = True
btnConnect.Enabled = False
OnLine = True

JoyStickLoop
End Sub

Private Sub Form_Load()
CommPort.AddItem "1"
CommPort.AddItem "2"
CommPort.AddItem "3"
CommPort.AddItem "4"
CommPort.AddItem "5"
CommPort.AddItem "6"
CommPort.AddItem "7"
CommPort.AddItem "8"
CommPort.AddItem "9"
CommPort.AddItem "10"
CommPort.AddItem "11"
CommPort.AddItem "12"
CommPort.AddItem "13"
CommPort.AddItem "14"
CommPort.AddItem "15"
CommPort.AddItem "16"
CommPort.AddItem "17"
CommPort.AddItem "18"
CommPort.AddItem "19"
End Sub
Private Sub Form_Unload(Cancel As Integer)
OnLine = False
'Disconnect the JoyStick link
diDev.Unacquire
Set diDev = Nothing
Set diDevEnum = Nothing
Set di = Nothing
End Sub

